type action = Ast | Bytecode | Compile

let _ =
  let (action, file_idx) = if Array.length Sys.argv > 2 then
    (List.assoc Sys.argv.(1) [ ("-a", Ast);
			      ("-b", Bytecode);
			      ("-c", Compile) ], 2)
  else (Compile, 1) in
  let lexbuf = Lexing.from_channel (open_in (Sys.argv.(file_idx))) in
  let learn_program = Parser.learn_program Scanner.token lexbuf in
  match action with
    Ast -> let listing = Ast.string_of_learn_program learn_program
           in print_string listing
  | Bytecode -> let listing =
      Bytecode.string_of_prog (Compile.translate learn_program)
    in print_endline listing
  | Compile -> Execute.execute_prog (Compile.translate learn_program)
